Attribute VB_Name = "ModuleInterpreter"

Option Explicit

'Valid demarcation characters in syntax
Const SYNTAX_COMMAND = "'( "
Const SYNTAX_ARGUMENT = ",) "
'Accepted examples:
'       PlayTone 400 500
'       PlayTone 400,500
'       PlayTone(400,500)
'       PlayTone (400, 500)
'       'Comment
'Commands are case insensitive
'Pausedownloadis automatically added after
' EndOfTask and EndOfSub, ALSO when it is already
' in the textfile (adding to the total pause time)


Public Sub InterpreteFile(FileName As String)
Dim MyChar As String * 1
Dim Line As String
Dim LineCount As Integer
Line = "": MyChar = "": LineCount = 1
Open FileName For Input As #1 ' Open file.
Do While Not EOF(1) ' Loop until end of file.
    MyChar = Input(1, #1)   ' Get one character.
    If MyChar = vbCr Then 'end of line
        InterpreteLine Line, LineCount
        LineCount = LineCount + 1
        MyChar = Input(1, #1) 'read extra vbLf
        Line = ""
    Else
        Line = Line & MyChar
    End If
Loop
If Line <> "" Then InterpreteLine Line, LineCount 'last line without CR
Close #1    ' Close file.
End Sub

Private Sub InterpreteLine(Line As String, LineCount As Integer)
Dim Result As String
Dim Comment As String
        Debug.Print Line  ' Print to Debug window.

'tidy up the input, this is very shaky
Line = LCase(Line)              'all lowercase
Line = Trim(Line)               'trim spaces
ReplaceAll Line, Chr(9), ""     'remove tabs
Line = TrimDot(Line)            'trim start dot
ReplaceAll Line, ", ", ","      'remove spaces after commas
ReplaceAll Line, " & ", "&"     'remove spaces around amps
ReplaceAll Line, " (", "("      'remove spaces before opening bracket
ReplaceAll Line, Chr(34), ""    'remove quotation marks around strings"
CutString Line, "'", Line, Comment 'discard comment on end of line
        Debug.Print Line  ' Print to Debug window.

Select Case CommandOf(Line)
Case ""
    Result = "Comment or empty line"
Case "pausedownload" 'add a pause, not a Spirit command!
    PauseDownload Val(NextArgument(Line))
Case "aboutbox"
    frmMain.Spirit1.AboutBox

    'Table of contents
    'TASKING
    'PROGRAM STRUCTURES
    'VARIABLE MANIPULATION
    'DATALOG
    'MOTOR COMMANDS
    'SENSOR COMMANDS
    'MESSAGING
    'DISPLAY
    'SOUND
    'PBRICKPOWER

'TASKING
Case "beginofsub"
    frmMain.Spirit1.BeginOfSub NextArgument(Line)
Case "endofsub"
    frmMain.Spirit1.EndOfSub
    PauseDownload 2 'note this pause!
Case "endofsubnodownload"
    frmMain.Spirit1.EndOfSubNoDownload
    PauseDownload 2 'neccesary?
Case "gosub"
    frmMain.Spirit1.GoSub NextArgument(Line)
Case "deletesub"
    frmMain.Spirit1.DeleteSub NextArgument(Line)
Case "deleteallsubs"
    Result = "I must reset"
    frmMain.Spirit1.DeleteAllSubs
Case "beginoftask"
    frmMain.Spirit1.BeginOfTask NextArgument(Line)
Case "endoftask"
    frmMain.Spirit1.EndOfTask
    PauseDownload 2 'note this pause!
Case "endoftasknodownload"
    frmMain.Spirit1.EndOfTaskNoDownload
    PauseDownload 2 'neccesary?
Case "starttask"
    frmMain.Spirit1.StartTask NextArgument(Line)
Case "stoptask"
    frmMain.Spirit1.StopTask NextArgument(Line)
Case "stopalltasks"
    frmMain.Spirit1.StopAllTasks
Case "deletetask"
    frmMain.Spirit1.DeleteTask NextArgument(Line)
Case "deletealltasks"
    frmMain.Spirit1.DeleteAllTasks
Case "clearallevents"
    frmMain.Spirit1.ClearAllEvents
Case "clearevent"
    frmMain.Spirit1.ClearEvent AsSource(NextArgument(Line)), _
    NextArgument(Line)
Case "setevent"
    frmMain.Spirit1.SetEvent AsSource(NextArgument(Line)), _
    NextArgument(Line), NextArgument(Line)

'PROGRAM STRUCTURES
Case "if"
    frmMain.Spirit1.If _
        AsSource(NextArgument(Line)), NextArgument(Line), _
        AsOperator(NextArgument(Line)), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "else"
    frmMain.Spirit1.Else
Case "endif"
    frmMain.Spirit1.EndIf
Case "loop"
    frmMain.Spirit1.Loop _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "endloop"
    frmMain.Spirit1.EndLoop
Case "while"
    frmMain.Spirit1.While _
        AsSource(NextArgument(Line)), NextArgument(Line), _
        AsOperator(NextArgument(Line)), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "endwhile"
    frmMain.Spirit1.EndWhile
Case "wait"
    frmMain.Spirit1.Wait _
    AsSource(NextArgument(Line)), NextArgument(Line)

'VARIABLE MANIPULATION
Case "setvar"
    frmMain.Spirit1.SetVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "sumvar"
    frmMain.Spirit1.SumVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "subvar"
    frmMain.Spirit1.SubVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "mulvar"
    frmMain.Spirit1.MulVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "divvar"
    frmMain.Spirit1.DivVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "andvar"
    frmMain.Spirit1.AndVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "orvar"
    frmMain.Spirit1.OrVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "sgnvar"
    frmMain.Spirit1.SgnVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)
Case "absvar"
    frmMain.Spirit1.AbsVar _
        NextArgument(Line), _
        AsSource(NextArgument(Line)), NextArgument(Line)

'DATALOG
Case "setdatalog"
    frmMain.Spirit1.SetDatalog NextArgument(Line)
Case "datalognext"
    frmMain.Spirit1.DatalogNext AsSource(NextArgument(Line)), NextArgument(Line)
Case "uploaddatalog"
    frmMain.Spirit1.UploadDatalog NextArgument(Line), NextArgument(Line)
Case "memmap"
    Result = frmMain.Spirit1.MemMap

'MOTOR COMMANDS
Case "on"
    frmMain.Spirit1.On AsMotorList(NextArgument(Line))
Case "off"
    frmMain.Spirit1.Off AsMotorList(NextArgument(Line))
Case "float"
    frmMain.Spirit1.Float AsMotorList(NextArgument(Line))
Case "setpower"
    frmMain.Spirit1.SetPower AsMotorList(NextArgument(Line)), _
    AsSource(NextArgument(Line)), NextArgument(Line)
Case "setfwd"
    frmMain.Spirit1.SetFwd AsMotorList(NextArgument(Line))
Case "setrwd"
    frmMain.Spirit1.SetRwd AsMotorList(NextArgument(Line))
Case "alterdir"
    frmMain.Spirit1.AlterDir AsMotorList(NextArgument(Line))
Case "onwait"
    frmMain.Spirit1.OnWait AsMotorList(NextArgument(Line)), _
    NextArgument(Line), NextArgument(Line)
Case "onwaitdifferent"
    frmMain.Spirit1.OnWaitDifferent AsMotorList(NextArgument(Line)), _
    NextArgument(Line), NextArgument(Line), NextArgument(Line), NextArgument(Line)
Case "cleartachocounter"
    frmMain.Spirit1.ClearTachoCounter AsMotorList(NextArgument(Line))

'SENSOR COMMANDS
Case "setsensortype"
    frmMain.Spirit1.SetSensorType NextArgument(Line), NextArgument(Line)
Case "setsensormode"
    frmMain.Spirit1.SetSensorMode NextArgument(Line), NextArgument(Line), NextArgument(Line)
Case "poll"
    frmMain.Spirit1.Poll AsSource(NextArgument(Line)), NextArgument(Line)
Case "clearsensorvalue"
    frmMain.Spirit1.ClearSensorValue NextArgument(Line)

'MESSAGING
Case "sendpbmessage"
    frmMain.Spirit1.SendPBMessage AsSource(NextArgument(Line)), NextArgument(Line)
Case "clearpbmessage"
    frmMain.Spirit1.ClearPBMessage

'DISPLAY
Case "selectdisplay"
    frmMain.Spirit1.SelectDisplay AsSource(NextArgument(Line)), NextArgument(Line)
Case "setwatch"
    frmMain.Spirit1.SetWatch NextArgument(Line), NextArgument(Line)

'SOUND
Case "playsystemsound"
    frmMain.Spirit1.PlaySystemSound NextArgument(Line)
Case "playtone"
    frmMain.Spirit1.PlayTone Val(NextArgument(Line)), Val(NextArgument(Line))

'PBRICKPOWER
Case "pbturnoff"
    frmMain.Spirit1.PBTurnOff
Case "pbpowerdowntime"
    frmMain.Spirit1.PBPowerdownTime NextArgument(Line)

'unknown
Case "drive"
    frmMain.Spirit1.Drive NextArgument(Line), NextArgument(Line)


Case Else
    Result = "Command " & Command & " not recognized in line " & LineCount
    MsgBox ("Command " & Command & " not recognized in line " & LineCount)
    fDownload.TextLog.Text = fDownload.TextLog.Text & vbCrLf & _
    "Command " & Command & " not recognized in line " & LineCount

    
End Select
Debug.Print "Line " & LineCount & ": " & Result
End Sub

Private Function CommandOf(Line As String) As String
'This is funky programming!
CutString Line, SYNTAX_COMMAND, CommandOf, Line
Debug.Print CommandOf
End Function

Private Function NextArgument(Arguments As String) As String
'More funky programming
CutString Arguments, SYNTAX_ARGUMENT, NextArgument, Arguments
End Function


Private Function LookFor(Line As String, Match As String) As Integer
LookFor = InStr(1, Line, Match, 1) 'textual compare, case insensitive
End Function


Private Function CutString(Phrase As String, _
        Cuts As String, InFront As String, Behind As String) _
        As Boolean
        'splits string in two parts, cuts may be a string _
        of MULTIPLE possible demarcation characters
    Dim cutpos As Integer
    Dim Finished As Boolean
    Dim Cycle As Integer
    Dim CutChar As String * 1
    Cycle = 1
    For Cycle = 1 To Len(Cuts)
        CutChar = Mid(Cuts, Cycle, 1) 'cycles through Cut list

        cutpos = LookFor(Phrase, CutChar) 'look for this Cut char
        If cutpos > 0 Then  'Cut char found
            If cutpos = 1 Then  'Cut Char is first char of Phrase
                InFront = ""
                Behind = Mid(Phrase, cutpos + 1)
            ElseIf cutpos = Len(Phrase) Then 'Cut Char is last char of Phrase
                InFront = Left(Phrase, cutpos - 1)
                Behind = ""
            Else 'Cut Char is somewhere else along Phrase
                InFront = Left(Phrase, cutpos - 1)
                Behind = Mid(Phrase, cutpos + 1)
            End If
            CutString = True

            Exit Function   'EXIT HERE
        End If
        
    Next
    'if no Cut character found
    InFront = Phrase
    Behind = ""
    CutString = False
End Function

Private Function AsSource(ConstName As String)
Debug.Print (ConstName)
    AsSource = Switch( _
    ConstName = "variable", 0, _
    ConstName = "timer", 1, _
    ConstName = "number", 2, _
    ConstName = "outputport", 3, _
    ConstName = "random", 4, _
    ConstName = "sensor", 9, _
    ConstName = "sensor_raw", 12, _
    ConstName = "minutes", 14, _
    ConstName = "inmessage", 15, _
    ConstName = "var", 0, _
    ConstName = "con", 2, _
    ConstName = "motsta", 3, _
    ConstName = "ran", 4, _
    ConstName = "tacc", 5, ConstName = "tacs", 6, _
    ConstName = "motcur", 7, _
    ConstName = "keys", 8, _
    ConstName = "senval", 9, ConstName = "sentype", 10, _
    ConstName = "senmode", 11, ConstName = "senraw", 12, _
    ConstName = "bool", 13, _
    ConstName = "watch", 14, _
    ConstName = "pbmess", 15, _
    True, ConstName) 'else return input unchanged
End Function

Private Function AsOperator(ConstName As String)
Debug.Print (ConstName)
    AsOperator = Switch( _
    ConstName = "greater_than", 0, _
    ConstName = "less_than", 1, _
    ConstName = "equal_to", 2, _
    ConstName = "not_equal_to", 3, _
    ConstName = "gt", 0, _
    ConstName = "lt", 1, _
    ConstName = "eq", 2, _
    ConstName = "ne", 3, _
    True, ConstName) 'else return input unchanged
End Function


Private Function AsMotorList(InString As String)
    Debug.Print ("motorlist: " & InString)
    Replace InString, "motor_a", "0"
    Replace InString, "motor_b", "1"
    Replace InString, "motor_c", "2"
    Replace InString, "output_a", "0"
    Replace InString, "output_b", "1"
    Replace InString, "output_c", "2"
    ReplaceAll InString, "&", ""    'remove ampersands
    ReplaceAll InString, " ", ""       'remove spaces
    'cleaning not really neccesary for motorlist argument
    AsMotorList = InString
    Debug.Print ("motorlist: " & InString)
End Function

Private Function Replace(Phrase As String, _
        Search As String, Replacement As String) _
        As Boolean
        'replaces part of a string
        'replaces ONLY FIRST OCCURANCE!
        Dim cutpos As Integer
        cutpos = LookFor(Phrase, Search)
        If cutpos > 0 Then  'Search string found
            Phrase = _
                Left(Phrase, cutpos - 1) & _
                Replacement & _
                Mid(Phrase, cutpos + Len(Search))
            Replace = True
        Else 'not found
        Replace = False 'phrase unchanged
        End If
End Function

Private Sub ReplaceAll(Phrase As String, _
        Search As String, Replacement As String)
    Do While Replace(Phrase, Search, Replacement)
    Loop
End Sub

Private Function TrimDot(Phrase As String) As String
'remove dot if it's start of string
If Left(Phrase, 1) = "." Then
    TrimDot = Mid(Phrase, 2, Len(Phrase) - 1)
Else
    TrimDot = Phrase
End If
End Function

Private Sub dotest(Line As String)
Debug.Print Line
ReplaceAll Line, "xyz", "12"
Debug.Print Line
End Sub
