Attribute VB_Name = "ModulePrograms"
Option Explicit

Public Enum SpiritValue
    variable = 0
    Timer = 1
    Number = 2
    OUTPUTPORT = 3
    RANDOM = 4
    TACHO = 5
    TACHOSPEED = 6
    SENSOR = 9
    SENSOR_RAW = 12
    MINUTES = 14
    INMESSAGE = 15
End Enum

Public Enum SpiritOperator
    greater_than = 0
    less_than = 1
    EQUAL_TO = 2
    NOT_EQUAL_TO = 3
End Enum

'Private Const MOTOR_A = "0" 'zijn al publiek bekend
'Private Const MOTOR_B = "1"
'Private Const MOTOR_C = "2"
'Public constants cannot be declared in a form or class module.

Public Sub LoadProgram(Prognr As Integer)
Select Case Prognr
    Case 1
    LEGOprogram1
    Case 2
    LEGOprogram2
    Case 3
    Testprogram3
    Case 4
    Testprogram4
    Case 5
    Testprogram5
    Case 6
    Testprogram6
    Case 7
    Testprogram7
    Case 8
    Testprogram8
    Case 9
    Testprogram9

Case Else
MsgBox ("Doesn't exist")
End Select
End Sub



'ALGEMEEN STRAMIEN
Public Sub firstprogram()
fMain.Spirit1.SelectPrgm (3)
fMain.Spirit1.BeginOfSub (3)
'code for subroutine 3
fMain.Spirit1.EndOfSub
'other subroutines
fMain.Spirit1.BeginOfSub (6)
'code for subroutine 6
fMain.Spirit1.EndOfSub
fMain.Spirit1.BeginOfTask (1)
'code for task 1
fMain.Spirit1.EndOfTask
'other tasks
fMain.Spirit1.BeginOfTask (0)
'code for task 0, start other tasks from here
fMain.Spirit1.EndOfTask

' NESTED CONTROL LOOPS wel mogelijk!
'one transmission for each endtask/sub
'wait a sec after each endtask/sub

End Sub

Private Sub LEGOprogram1()
'constant power
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .PlaySystemSound 1
    .SetVar 1, Number, 1 'variable 1 gets value 1
    .While variable, 1, greater_than, Number, 0 'eternal loop
        .On (motor_a & motor_c)
    .EndWhile
    'Without the while-loop, the motors will stay on after the program is stopped!!
.EndOfTask
End With
End Sub

Private Sub LEGOprogram2()
'two touch sensors stop a motor each
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .SetVar 1, Number, 1 'variable 1 gets value 1
    .While variable, 1, greater_than, Number, 0 'eternal loop
        .If SENSOR, 0, EQUAL_TO, Number, 0
            .On (motor_a)
        .Else
            .Off (motor_a)
        .EndIf
    .EndWhile
.EndOfTask
PauseDownload 2
.BeginOfTask 2
    .SetVar 1, Number, 1 'variable 1 gets value 1
    .While variable, 1, greater_than, Number, 0 'eternal loop
        .If SENSOR, 2, EQUAL_TO, Number, 0
            .On (motor_c)
        .Else
            .Off (motor_c)
        .EndIf
    .EndWhile
.EndOfTask
PauseDownload 2
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
.EndOfTask
End With
End Sub

    'Dit blijkt niet als eternal loop te werken:
    '.While NUMBER, 1, GREATER_THAN, NUMBER, 0
    'Loop counts down by itself, even Loop NUMBER 1
    
    'Dit lijkt soms wel en soms niet als eternal te werken:
    '.Loop NUMBER, 1 'eternal loop





Private Sub Testprogram1()
'musical
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .PlayTone 400, 200
    .PlayTone 800, 200
    .PlayTone 1600, 200
    .PlayTone 3200, 200
.EndOfTask
End With
End Sub

Private Sub Testprogram2()
'count seven tones
With fMain.Spirit1
.DeleteAllTasks
    .BeginOfTask (0)
    .SetVar 3, Number, 7 'variabele 3 waarde 7
    .Loop variable, 3 'zolang var 3 groter dan nul, telt vanzelf af!
        .PlaySystemSound (4)
        .Wait Number, 100 'wait 1 sec
        .PlaySystemSound (0)
    .EndLoop
    .PlaySystemSound (1)
    .EndOfTask
End With
End Sub

Private Sub Testprogram3()
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .PlayTone 400, 1000
.EndOfTask
PauseDownload 1
.BeginOfTask 2
    .PlaySystemSound (2)
.EndOfTask
PauseDownload 1
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
.EndOfTask
End With
End Sub



Private Sub Testprogram4()
'eternal siren
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask (0)
    .SetVar 3, Number, 7 'variabele 3 waarde 7
    .While variable, 3, greater_than, Number, 0 'eternal loop
        .PlayTone 440, 10
        .Wait Number, 10
        .PlayTone 840, 10
        .Wait Number, 10
    .EndWhile
    .PlaySystemSound (1)
.EndOfTask
End With
End Sub

Private Sub Testprogram5_1()
'
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .While SENSOR, 0, EQUAL_TO, Number, 0
        .PlayTone 400, 1
    .EndWhile
    .PlayTone 800, 10
.EndOfTask
.BeginOfTask 0
    .StartTask 1
    .SetVar 0, Number, 1
    .While variable, 0, EQUAL_TO, Number, 1
    .EndWhile
.EndOfTask
End With
End Sub


Private Sub Testprogram5()
'Respond to sensor
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .While SENSOR, 0, EQUAL_TO, Number, 0
        .PlayTone 400, 1
    .EndWhile
    .PlayTone 800, 10
.EndOfTask
End With
End Sub

Private Sub Testprogram5_()
'Respond to variable value
'used for cm to rcx communication
'put this in the RCX
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .SetVar 5, Number, 20

    .SetVar 1, Number, 1 'variable 1 gets value 1
    .While variable, 1, greater_than, Number, 0 'eternal loop

    .If variable, 5, EQUAL_TO, Number, 23
        .PlaySystemSound (3)
    '.Else
        '.PlaySystemSound (0)
    .EndIf
    
    .EndWhile
.EndOfTask
End With
End Sub

Private Sub Testprogram6_()
'Set variable value
'used for cm to rcx communication
'put this in the CM
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .SetSensorType 1, 1 'touch
    .SetSensorMode 1, 1, 1 'boolean
    
    .SetVar 1, Number, 1 'variable 1 gets value 1
    .While variable, 1, greater_than, Number, 0 'eternal loop

    .If SENSOR, 1, greater_than, Number, 0
        .SetVar 5, Number, 23
        .SendPBMessage Number, 123
    .Else
        .SetVar 5, Number, 20
    .EndIf
    
    .EndWhile
.EndOfTask
End With
End Sub



Private Sub Testprogram6()
'Three sensors control three motors
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .SetVar 1, Number, 1 'variable 1 gets value 1
    .While variable, 1, greater_than, Number, 0 'eternal loop
        .If SENSOR, 0, EQUAL_TO, Number, 1
            .On (motor_a)
        .Else
            .Off (motor_a)
        .EndIf
    .EndWhile
.EndOfTask
PauseDownload 2
.BeginOfTask 2
    .SetVar 2, Number, 1 'variable 2 gets value 1
    .While variable, 2, greater_than, Number, 0 'eternal loop
        .If SENSOR, 1, EQUAL_TO, Number, 1
            .On (motor_b)
        .Else
            .Off (motor_b)
        .EndIf
    .EndWhile
.EndOfTask
PauseDownload 2
.BeginOfTask 3
    .SetVar 3, Number, 1 'variable 3 gets value 1
    .While variable, 3, greater_than, Number, 0 'eternal loop
        .If SENSOR, 2, EQUAL_TO, Number, 1
            .On (motor_c)
        .Else
            .Off (motor_c)
        .EndIf
    .EndWhile
.EndOfTask
PauseDownload 2
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
    .StartTask 3
.EndOfTask
End With
End Sub

Private Sub Testprogram7()
'random tones
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .SetVar 1, Number, 1 'variable 1 gets value 1
    .While variable, 1, greater_than, Number, 0 'eternal loop
        .SetVar 2, RANDOM, 3 'random integers van 0 tot n
        .If variable, 2, EQUAL_TO, Number, 0
            .PlayTone 400, 1
        .EndIf
        .If variable, 2, EQUAL_TO, Number, 1
            .PlayTone 800, 1
        .EndIf
        .If variable, 2, EQUAL_TO, Number, 2
            .PlayTone 1600, 1
        .EndIf
        .If variable, 2, EQUAL_TO, Number, 3
            .PlayTone 3200, 1
        .EndIf
        .Wait RANDOM, 100
    .EndWhile
.EndOfTask
End With
End Sub


Private Sub Testprogram8()
'Random drift of motors
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1 'controls motor A
    .SetVar 1, Number, 1 'variable 1 gets value 1
    .While variable, 1, greater_than, Number, 0 'eternal loop
        .SetVar 2, RANDOM, 1
        .If variable, 2, greater_than, Number, 0
            .SetFwd motor_a
        .Else
            .SetRwd motor_a
        .EndIf
        .SetPower motor_a, RANDOM, 2
        .On motor_a
        .Wait Number, 100
        .Off motor_a
    .EndWhile
.EndOfTask
PauseDownload 1
.BeginOfTask 2 'controls motor B
    .SetVar 3, Number, 1 'variable 1 gets value 1
    .While variable, 3, greater_than, Number, 0 'eternal loop
        .SetVar 4, RANDOM, 1
        .If variable, 4, greater_than, Number, 0
            .SetFwd motor_b
        .Else
            .SetRwd motor_b
        .EndIf
        .SetPower motor_b, RANDOM, 2
        .On motor_b
        .Wait Number, 100
        .Off motor_b
    .EndWhile
.EndOfTask
PauseDownload 1
.BeginOfTask 3 'controls motor C
    .SetVar 5, Number, 1 'variable 1 gets value 1
    .While variable, 5, greater_than, Number, 0 'eternal loop
        .SetVar 6, RANDOM, 1
        .If variable, 6, greater_than, Number, 0
            .SetFwd motor_c
        .Else
            .SetRwd motor_c
        .EndIf
        .SetPower motor_c, RANDOM, 2
        .On motor_c
        .Wait RANDOM, 100
        .Off motor_c
    .EndWhile
.EndOfTask
PauseDownload 1

.BeginOfTask 0
    '.On MOTOR_A & MOTOR_B & MOTOR_C
    '.SetPower MOTOR_A & MOTOR_B & MOTOR_C, NUMBER, 5
    .StartTask 1
    .StartTask 2
    .StartTask 3
.EndOfTask

End With
End Sub

'for some reason this gives a download error:
'        .If RANDOM, 1, GREATER_THAN, NUMBER, 0



Private Sub Testprogram9oud()
'Random drift of motors, short version, more cryptic
Dim ThisMotor As MotorName
Dim ThisVar As Integer
With fMain.Spirit1
.DeleteAllTasks
For ThisMotor = motor_a To motor_c  'three tasks, one for each motor
.BeginOfTask ThisMotor + 1          'start with task 1
    ThisVar = (2 * ThisMotor) + 1   'series 1,3,5
    .SetVar ThisVar, Number, 1      'variable 1 gets value 1
    .While variable, ThisVar, greater_than, Number, 0 'eternal loop
        .SetVar ThisVar + 1, RANDOM, 1
        .If variable, ThisVar + 1, greater_than, Number, 0
            .SetFwd ThisMotor
        .Else
            .SetRwd ThisMotor
        .EndIf
        .SetPower ThisMotor, RANDOM, 2
        .On ThisMotor
        .Wait RANDOM, 100
        .Off ThisMotor
    .EndWhile
.EndOfTask
PauseDownload 1
Next ThisMotor
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
    .StartTask 3
.EndOfTask
End With
End Sub

Private Sub Testprogram9over()
'synchronise two motors CM, doesn't work well
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1 'monitor motor a
.Loop Number, 0
    .If TACHOSPEED, motor_a, greater_than, variable, 19
        .SubVar 20, Number, 1  'decrease actual speed
        .SetPower motor_a, variable, 20
    .Else
        .If TACHOSPEED, motor_a, less_than, variable, 19
        .SumVar 20, Number, 1  'decrease actual speed
        .SetPower motor_a, variable, 20
        .EndIf
    .EndIf
.EndLoop
.EndOfTask

.BeginOfTask 2 'monitor motor b
.Loop Number, 0
    .If TACHOSPEED, motor_b, greater_than, variable, 19
        .SubVar 21, Number, 1  'decrease actual speed
        .SetPower motor_b, variable, 21
    .Else
        .If TACHOSPEED, motor_b, less_than, variable, 19
        .SumVar 21, Number, 1  'decrease actual speed
        .SetPower motor_b, variable, 21
        .EndIf
    .EndIf
.EndLoop
.EndOfTask

.BeginOfTask 0
    .SetFwd motor_a & motor_b
    .On motor_a & motor_b
    .SetVar 19, Number, 10 'target tachospeed 0-90
    .SetVar 20, Number, 4 'actual speed a 0-7
    .SetVar 21, Number, 4 'actual speed b 0-7
    .StartTask 1 'monitor motor a
    .StartTask 2 'monitor motor b
.EndOfTask

End With
End Sub

Private Sub Testprogram9oud1()
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1 'synchronise motors
.Loop Number, 0
    .If TACHO, motor_a, greater_than, TACHO, motor_b
        .If variable, 20, greater_than, Number, 0
        .SubVar 20, Number, 1  'decrease actual speed a
        .EndIf
        .SetPower motor_a, variable, 20
        .If variable, 21, less_than, Number, 8
        .SumVar 21, Number, 1
        .EndIf
        .SetPower motor_b, variable, 21
    .Else
        .If TACHO, motor_a, less_than, TACHO, motor_b
        .If variable, 20, less_than, Number, 8
            .SumVar 20, Number, 1  'increase actual speed a
        .EndIf
        .SetPower motor_a, variable, 20
        .If variable, 21, greater_than, Number, 0
        .SubVar 21, Number, 1
        .EndIf
        .SetPower motor_b, variable, 21
        .EndIf
    .EndIf
.EndLoop
.EndOfTask
PauseDownload 2
.BeginOfTask 0
    .ClearTachoCounter motor_a & motor_b
    .SetFwd motor_a & motor_b
    .On motor_a & motor_b
    .SetVar 19, Number, 10 'target tachospeed 0-90
    .SetVar 20, Number, 4 'actual speed a 0-7
    .SetVar 21, Number, 4 'actual speed b 0-7
    .StartTask 1 'monitor motors
.EndOfTask

End With
End Sub

Private Sub Testprogram9()
With fMain.Spirit1
.DeleteAllTasks
.DeleteAllSubs
.BeginOfTask 0
    .ClearTachoCounter motor_a & motor_b
    .SetFwd motor_a & motor_b
    .On motor_a & motor_b
    .StartTask 1
.EndOfTask
PauseDownload 2
.BeginOfTask 1
.Loop 2, 0
    .SetVar 20, TACHO, motor_a
    .SetVar 21, TACHO, motor_b 'difference
    .SetVar 18, variable, 20
    .SubVar 18, variable, 21
    .SetVar 19, variable, 18 'debug
    .If variable, 18, greater_than, Number, 2
        .Off motor_a
    .Else
        .If variable, 18, less_than, Number, -2
        .Off motor_b
        .Else
            .On motor_a & motor_b
        .EndIf
    .EndIf
.EndLoop
.EndOfTask

End With
End Sub


Public Sub PauseDownload(Seconds As Integer)
Dim Begin As Date
Begin = Now
Do Until DateDiff("s", Begin, Now) = Seconds
'wait
Loop
End Sub



